import { world, ItemStack, Location, MinecraftItemTypes, system, BlockLocation } from "@minecraft/server"
let itemList = Object.keys(MinecraftItemTypes)

function randomItem() {
    let keys = Object.keys(MinecraftItemTypes)
    return MinecraftItemTypes[keys[keys.length * Math.random() << 0]]
}
world.events.blockBreak.subscribe(ev => {
    const plr = ev.player
    let locX = ev.block.location.x
    let locY = ev.block.location.y
    let locZ = ev.block.location.z

    system.run(() => {
        world.getDimension('overworld').runCommandAsync(`execute positioned ${locX} ${locY} ${locZ} run kill @e[c=1,type=item]`)
        world.getDimension("overworld").spawnItem(new ItemStack(randomItem(), 1, 0), new Location(locX, locY, locZ))
    })
})



//2nd version
const blockList = Object.keys(MinecraftBlockTypes)
let list1 = Object.keys(MinecraftItemTypes)
let list2 = []


function randomItem(x) {
    let keys = Object.keys(MinecraftItemTypes)
    return MinecraftItemTypes[keys[x]]
}

world.events.beforeChat.subscribe(ev => {
    const msg = ev.message
    const plr = ev.sender

    if (msg == '+sort') {
        for (let i = 0; i < list1.length; i++) {
            list2.push(list1[i])
        }
        list2.sort(() => Math.random() - 0.5);
    } else if (msg == '+blocks') {
        for (let i = 0; i < list1.length; i++) {
            plr.runCommandAsync(`say ${blockList[i]} ${i}`)
        }
    }
})



world.events.blockBreak.subscribe(ev => {
    const plr = ev.player
    const blk = ev.brokenBlockPermutation.type.id
    let locX = ev.block.location.x
    let locY = ev.block.location.y
    let locZ = ev.block.location.z

    for (let i = 0; i < list1.length; i++) {
        if (blk.slice(10) == blockList[i]) {
            world.getDimension("overworld").spawnItem(new ItemStack(randomItem(i), 1, 0), new Location(locX, locY, locZ))
        }
    }

})